--[[
BMR - Button Mashing Revolution
a DDR clone

By Sam
Images by Sam and Chris

www.pspevolution.com

Version 1.0

]]--
screen:clear()
screen:print(175,120,"Loading...",Color.new(255,255,255))
screen.flip()
blank    = Image.createEmpty(50, 50)
score_color = Image.load("scorecolor.png")
great_image = Image.load("great.png")
perfect_image = Image.load("perfect.png")
boo_image = Image.load("boo.png")
miss_image = Image.load("miss.png")
menu = Image.load("menu.png")
menu_transparency = Image.createEmpty(480,272)
menu_transparency:blit(165,74,menu)
square_target   = Image.load("square_target.png")
triangle_target = Image.load("triangle_target.png")
cross_target    = Image.load("cross_target.png")
circle_target   = Image.load("circle_target.png")
options_screen = Image.load("options_screen.png")
loading_screen = Image.load("loading_screen.png")
grading_screen = Image.load("grade.png")
bgmusic = "music1.xm"
gray = Color.new(122,122,122)
black = Color.new(0, 0, 0)
white = Color.new(255,255,255)
difficulty = 2.3
createrandom = "true"
bgmusictext = "Unreleased"
randomvalue = 100
unlkeys = 6
bg_animation = "Stars"
difficulty_text = "Moderate"
while true do
	screen:clear(white)
	screen:blit(0,0,options_screen)
	input = Controls.read()
		if input:up() then
				if difficulty == 1.5 then
					difficulty = 2.3
				elseif difficulty == 2.3 then
					difficulty = 3
				elseif difficulty == 3 then
					difficulty = 3.7
				end
			screen.waitVblankStart(12)
		elseif input:down() then
				if difficulty == 2.3 then
					difficulty = 1.5
				elseif difficulty == 3 then
					difficulty = 2.3
				elseif difficulty == 3.7 then
					difficulty = 3
				end
			screen.waitVblankStart(12)
		end

		if input:select() then
			if createrandom == "true" then
				createrandom = "unl"
			elseif createrandom == "unl" then
				createrandom = "false"
			elseif createrandom == "false" then
				createrandom = "true"
			end
		screen.waitVblankStart(12)
		end

		if input:circle() then
			if bg_animation == "Stars" then
				bg_animation = "3D Cube"
			elseif bg_animation == "3D Cube" then
				bg_animation = "Stars"
			end
		screen.waitVblankStart(12)
		end



		if input:start() then
			break
		end

		if difficulty == 1.5 then
			difficulty_text = "Easy"
		elseif difficulty == 2.3 then
			difficulty_text = "Moderate"
		elseif difficulty == 3 then
			difficulty_text = "Hard"
		elseif difficulty == 3.7 then
			difficulty_text = "Very Hard"
		end
	screen:print(240,146,"Difficulty: "..difficulty_text,white)
	screen:print(8,250,"Background Music: "..bgmusictext,white)
	screen:print(8,260," Coded by Sam  -  Images by Sam & Chris  -  TeamEvolution",white)
	screen:print(453,250,"1.0",white)
	screen:print(240,178,"Background Animation: "..bg_animation,white)
		if createrandom == "true" then
			screen:print(240,114,"Mode: Random Keys, Create "..randomvalue,white)
			if input:left() then
				randomvalue = randomvalue - 10
				screen.waitVblankStart(6)
			elseif input:right() then
				randomvalue = randomvalue + 10
				screen.waitVblankStart(6)
			end
			if randomvalue <= 0 then
				randomvalue = 1
			elseif randomvalue >= 2401 then
				randomvalue = 2400
			end
		elseif createrandom == "false" then
			screen:print(240,114,"Mode: Read 'keys.txt'",white)
		elseif createrandom == "unl" then
			screen:print(240,114,"Mode: Unlimited",white)
		end
		if input:l() then
			if bgmusic == "music1.xm" then
				bgmusic = "music6.xm"
				bgmusictext = "Landing"
			elseif bgmusic == "music2.xm" then
				bgmusic = "music1.xm"
				bgmusictext = "Unreleased"
			elseif bgmusic == "music3.xm" then
				bgmusic = "music2.xm"
				bgmusictext = [["The Ledgend"]]
			elseif bgmusic == "music4.xm" then
				bgmusic = "music3.xm"
				bgmusictext = "Sandman's Theme"
			elseif bgmusic == "music5.s3m" then
				bgmusic = "music4.xm"
				bgmusictext = "oravan pes,, suussa!"
			elseif bgmusic == "music6.xm" then
				bgmusic = "music5.s3m"
				bgmusictext = "arxy"
			end
		screen.waitVblankStart(10)
		end
		if input:r() then
			if bgmusic == "music1.xm" then
				bgmusic = "music2.xm"
				bgmusictext = [["The Ledgend"]]
			elseif bgmusic == "music2.xm" then
				bgmusic = "music3.xm"
				bgmusictext = "Sandman's Theme"
			elseif bgmusic == "music3.xm" then
				bgmusic = "music4.xm"
				bgmusictext = "oravan pes,, suussa!"
			elseif bgmusic == "music4.xm" then
				bgmusic = "music5.s3m"
				bgmusictext = "arxy"
			elseif bgmusic == "music5.s3m" then
				bgmusic = "music6.xm"
				bgmusictext = "Landing"
			elseif bgmusic == "music6.xm" then
				bgmusic = "music1.xm"
				bgmusictext = "Unreleased"
			end
		screen.waitVblankStart(10)
		end

	screen.flip()
end
key_text_file = "keys.txt"
key = {}
------------------------------------------------------------------------
function Image:magnify(mag)
  mag = mag or 2           -- 2 times in size by default
  local wm = self:width()  
  local hm = self:height()
  local result = Image.createEmpty(480,272)
  for xm = 0, wm-1 do
    for ym = 0, hm-1 do
      result:fillRect(mag*xm, mag*ym, mag,mag, self:pixel(xm,ym))
    end
  end
  return result
end
---------
function Image:caption(xm,ym, text, color, fontsize)
  fontsize = fontsize or 1
  local wm = string.len(text)
  local temp = Image.createEmpty(8 * wm, 8)
  temp:print(0,0, text, color)
  if fontsize > 1 then 
    temp = temp:magnify(fontsize)
  end
  self:blit(xm,ym, temp)
end
------------------------------------------------------------------------

function loadKeys()
	file = io.open(key_text_file, "r")
	openloop = 1
	if file then
		for line in file:lines() do
				if string.sub(line,0,1) == "[" or string.sub(line,0,1) == "^" or string.sub(line,0,1) == "O" or string.sub(line,0,1) == "X" then
					key[openloop] = string.sub(line,0,1)
					openloop = openloop + 1
				end
		end
	file:close()
	end
end

-------------------------------------------------------------------------

function keybrowser()
	--loadKeys()
	--while not Controls.read():start() do
	--screen:clear(gray)
		for i=1,table.getn(key) do
				screen:print(0, i*10, key[i])
		end
	--screen:print(30,1,table.getn(key))
	--screen.flip()
	--end
end
-------------------------------------------------------------------------

function transferandcreatenew() -- call this when you press the correct button

if createrandom == "unl" then --for unlimited mode
	random_int2 = math.random(4)
		if random_int2 == 1 then
			key[startkeys+5] = "X"
		elseif random_int2 == 2 then
			key[startkeys+5] = "O"
		elseif random_int2 == 3 then
			key[startkeys+5] = "^"
		elseif random_int2 == 4 then
			key[startkeys+5] = "["
		end
end                           --------------------



startkeys = startkeys + 1
current_y = current_y + 51
	object1 = object2
	object2 = object3
	object3 = object4
	object4 = object5
if startkeys + 3 == table.getn(key) then
object5 = blank
else
	if key[startkeys+4] == "X" then
		object5 = cross
	elseif key[startkeys+4] == "[" then
		object5 = square
	elseif key[startkeys+4] == "O" then
		object5 = circle
	elseif key[startkeys+4] == "^" then
		object5 = triangle
	end
end
collectgarbage()
end
---------------------------------------------------------

function startup()

if createrandom == "unl" then
	createrandom_int = math.random(4)
		if createrandom_int == 1 then
			key[startkeys] = "X"
		elseif createrandom_int == 2 then
			key[startkeys] = "O"
		elseif createrandom_int == 3 then
			key[startkeys] = "^"
		elseif createrandom_int == 4 then
			key[startkeys] = "["
		end

	createrandom_int = math.random(4)
		if createrandom_int == 1 then
			key[startkeys+1] = "X"
		elseif createrandom_int == 2 then
			key[startkeys+1] = "O"
		elseif createrandom_int == 3 then
			key[startkeys+1] = "^"
		elseif createrandom_int == 4 then
			key[startkeys+1] = "["
		end

	createrandom_int = math.random(4)
		if createrandom_int == 1 then
			key[startkeys+2] = "X"
		elseif createrandom_int == 2 then
			key[startkeys+2] = "O"
		elseif createrandom_int == 3 then
			key[startkeys+2] = "^"
		elseif createrandom_int == 4 then
			key[startkeys+2] = "["
		end

	createrandom_int = math.random(4)
		if createrandom_int == 1 then
			key[startkeys+3] = "X"
		elseif createrandom_int == 2 then
			key[startkeys+3] = "O"
		elseif createrandom_int == 3 then
			key[startkeys+3] = "^"
		elseif createrandom_int == 4 then
			key[startkeys+3] = "["
		end

	createrandom_int = math.random(4)
		if createrandom_int == 1 then
			key[startkeys+4] = "X"
		elseif createrandom_int == 2 then
			key[startkeys+4] = "O"
		elseif createrandom_int == 3 then
			key[startkeys+4] = "^"
		elseif createrandom_int == 4 then
			key[startkeys+4] = "["
		end
	createrandom_int = math.random(4)
		if createrandom_int == 1 then
			key[startkeys+5] = "X"
		elseif createrandom_int == 2 then
			key[startkeys+5] = "O"
		elseif createrandom_int == 3 then
			key[startkeys+5] = "^"
		elseif createrandom_int == 4 then
			key[startkeys+5] = "["
		end
end

if bg_animation == "Stars" then
color_ = Color.new(255,255,255)
	square   = Image.load("square_white.png")
	triangle = Image.load("triangle_white.png")
	cross    = Image.load("cross_white.png")
	circle   = Image.load("circle_white.png")
score_template = Image.load("scoretemplate_black.png")
	--Setup the starfield
	starfield = {}
	math.randomseed(os.time())

	for i = 1, 240 do
		createStar(i)
		starfield[i].z = math.random(5)
	end


elseif bg_animation == "3D Cube" then
color_ = Color.new(0,0,0)
score_template = Image.load("scoretemplate_white.png")
	square   = Image.load("square.png")
	triangle = Image.load("triangle.png")
	cross    = Image.load("cross.png")
	circle   = Image.load("circle.png")
end



	if key[startkeys] == "X" then
		object1= cross
	elseif key[startkeys] == "[" then
		object1 = square
	elseif key[startkeys] == "O" then
		object1= circle
	elseif key[startkeys] == "^" then
		object1 = triangle
	end
	if key[startkeys+1] == "X" then
		object2 = cross
	elseif key[startkeys+1] == "[" then
		object2 = square
	elseif key[startkeys+1] == "O" then
		object2 = circle
	elseif key[startkeys+1] == "^" then
		object2 = triangle
	end
	if key[startkeys+2] == "X" then
		object3 = cross
	elseif key[startkeys+2] == "[" then
		object3 = square
	elseif key[startkeys+2] == "O" then
		object3 = circle
	elseif key[startkeys+2] == "^" then
		object3 = triangle
	end
	if key[startkeys+3] == "X" then
		object4 = cross
	elseif key[startkeys+3] == "[" then
		object4 = square
	elseif key[startkeys+3] == "O" then
		object4 = circle
	elseif key[startkeys+3] == "^" then
		object4 = triangle
	end
	if key[startkeys+4] == "X" then
		object5 = cross
	elseif key[startkeys+4] == "[" then
		object5 = square
	elseif key[startkeys+4] == "O" then
		object5 = circle
	elseif key[startkeys+4] == "^" then
		object5  = triangle
	end



	starfield = {}
	math.randomseed(os.time())

	for i = 1, 240 do
		createStar(i)
		starfield[i].z = math.random(5)
	end

end
---------------------------------------------------------------------------
function draw()
if bg_animation == "Stars" then
drawstarfield()
elseif bg_animation == "3D Cube" then
rotateCube()
end
if score/3 <= 256 then
screen:blit(119,0,score_color,0,0,score/3,28)
else
screen:fillRect(119,0,256,28,white)
end
screen:blit(107,0,score_template)
screen:print(226,25,score,color_)
screen:blit(139+51,50,cross_target)
screen:blit(139+153,50,circle_target)
screen:blit(139,50,square_target)
screen:blit(139+102,50,triangle_target)
if object1 == cross then
	screen:blit(139+51,current_y,object1)
elseif object1 == circle then
	screen:blit(139+153,current_y,object1)
elseif object1 == square then
	screen:blit(139,current_y,object1)
elseif object1 == triangle then
	screen:blit(139+102,current_y,object1)
end

if object2 == cross then
	screen:blit(139+51,current_y+51,object2)
elseif object2 == circle then
	screen:blit(139+153,current_y+51,object2)
elseif object2 == square then
	screen:blit(139,current_y+51,object2)
elseif object2 == triangle then
	screen:blit(139+102,current_y+51,object2)
end

if object3 == cross then
	screen:blit(139+51,current_y+102,object3)
elseif object3 == circle then
	screen:blit(139+153,current_y+102,object3)
elseif object3 == square then
	screen:blit(139,current_y+102,object3)
elseif object3 == triangle then
	screen:blit(139+102,current_y+102,object3)
end

if object4 == cross then
	screen:blit(139+51,current_y+153,object4)
elseif object4 == circle then
	screen:blit(139+153,current_y+153,object4)
elseif object4 == square then
	screen:blit(139,current_y+153,object4)
elseif object4 == triangle then
	screen:blit(139+102,current_y+153,object4)
end

if object5 == cross then
	screen:blit(139+51,current_y+204,object5)
elseif object5 == circle then
	screen:blit(139+153,current_y+204,object5)
elseif object5 == square then
	screen:blit(139,current_y+204,object5)
elseif object5 == triangle then
	screen:blit(139+102,current_y+204,object5)
end
if show_status > 0 then
	if status == "Great" then
		screen:blit(189,155,great_image)
	elseif status == "Perfect!" then
		screen:blit(168,155,perfect_image)
	elseif status == "Boo" then
		screen:blit(208,155,boo_image)
	elseif status == "Miss" then
		screen:blit(202,155,miss_image)
	end
show_status = show_status - 1
end
end
-----------------------------------------------------------
function detectinput()
if key[startkeys] == "X" then
	if current_y < 71 then
		if input:cross() then
			if current_y < 55 and current_y > 45 then
				score = score + 2 + math.floor(difficulty)
				status = "Perfect!"
				perfect_count = perfect_count + 1
			elseif current_y < 61 and current_y > 45 then
				score = score + 1+ math.floor(difficulty)
				status = "Great"
				great_count = great_count + 1
			elseif current_y < 71 and current_y > 45 then
				score = score - 4
				status = "Boo"
				boo_count = boo_count + 1
			elseif current_y < 46 and current_y > 29 then
				score = score - 8
				status = "Boo"
				boo_count = boo_count + 1
			end
			show_status = 25
			transferandcreatenew()
		end
	end
end

if key[startkeys] == "O" then
	if current_y < 71 then
		if input:circle() then
			if current_y < 55 and current_y > 45 then
				score = score + 2+ math.floor(difficulty)
				status = "Perfect!"
				perfect_count = perfect_count + 1
			elseif current_y < 61 and current_y > 45 then
				score = score + 1+ math.floor(difficulty)
				status = "Great"
				great_count = great_count + 1
			elseif current_y < 71 and current_y > 45 then
				score = score - 4
				status = "Boo"
				boo_count = boo_count + 1
			elseif current_y < 46 and current_y > 29 then
				score = score - 8
				status = "Boo"
				boo_count = boo_count + 1
			end
			show_status = 25
			transferandcreatenew()
		end
	end
end

if key[startkeys] == "[" then
	if current_y < 71 then
		if input:square() then
			if current_y < 55 and current_y > 45 then
				score = score + 2+ math.floor(difficulty)
				status = "Perfect!"
				perfect_count = perfect_count + 1
			elseif current_y < 61 and current_y > 45 then
				score = score + 1+ math.floor(difficulty)
				status = "Great"
				great_count = great_count + 1
			elseif current_y < 71 and current_y > 45 then
				score = score - 4
				status = "Boo"
				boo_count = boo_count + 1
			elseif current_y < 46 and current_y > 29 then
				score = score - 8
				status = "Boo"
				boo_count = boo_count + 1
			end
			show_status = 25
			transferandcreatenew()
		end
	end
end

if key[startkeys] == "^" then
	if current_y < 71 then
		if input:triangle() then
			if current_y < 55 and current_y > 45 then
				score = score + 2+ math.floor(difficulty)
				status = "Perfect!"
				perfect_count = perfect_count + 1
			elseif current_y < 61 and current_y > 45 then
				score = score + 1+ math.floor(difficulty)
				status = "Great"
				great_count = great_count + 1
			elseif current_y < 71 and current_y > 45 then
				score = score - 4
				status = "Boo"
				boo_count = boo_count + 1
			elseif current_y < 46 and current_y > 29 then
				score = score - 8
				status = "Boo"
				boo_count = boo_count + 1
			end
			show_status = 25
			transferandcreatenew()
		end
	end
end
end
---------------------------------------------------------

function gameover()
		white = Color.new(255,255,255)
		screen:clear(white)
		draw()
		status = ""
		if score < 0 then
		score = 0
		end
		screen.flip()


			for b=1,240,6 do
				screen:clear(white)
				current_y = current_y - difficulty
				draw()
				screen:fillRect(0,0,b,272,color_)
				screen:fillRect(480-b,0,240,272,color_)
				screen.flip()
			end

			for b=240,1,-6 do
				screen:clear()
				screen:blit(0,0,grading_screen)
				screen:fillRect(0,0,b,272,color_)
				screen:fillRect(480-b,0,240,272,color_)
				screen.flip()
			end

randomvalue = perfect_count + great_count + boo_count + miss_count
grading_screen_layer = Image.createEmpty(480,272)

	screen:clear()
	screen:blit(0,0,grading_screen)
	screen.flip()
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen.flip()
if score >= 1 then
if (randomvalue*(2+ math.floor(difficulty)))*100 <= 0 then
score_add = 1
else
score_add = 0
end
	if (score)/(((randomvalue*(2+ math.floor(difficulty)))*100)+score_add) >= 93 then
	grading_screen_layer:caption(204,72,"AAA",white,5)

	elseif (score)/(((randomvalue*(2+ math.floor(difficulty)))*100)+score_add) >= 87 then
	grading_screen_layer:caption(219,72, "AA",white,5)

	elseif (score)/(((randomvalue*(2+ math.floor(difficulty)))*100)+score_add) >= 80 then
	grading_screen_layer:caption(240,72, "A",white,5)

	elseif (score)/(((randomvalue*(2+ math.floor(difficulty)))*100)+score_add) >= 65 then
	grading_screen_layer:caption(240,72, "B",white,5)

	elseif (score)/(((randomvalue*(2+ math.floor(difficulty)))*100)+score_add) >= 45 then
	grading_screen_layer:caption(240,72, "C",white,5)

	elseif (score)/(((randomvalue*(2+ math.floor(difficulty)))*100)+score_add) >= 25 then
	grading_screen_layer:caption(240,72, "D",white,5)

	else
	grading_screen_layer:caption(240,72, "E",white,5)

	end
elseif score <= 0 then
grading_screen_layer:caption(240,72, "-",white,5)
end
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen:blit(0,0,grading_screen_layer)
	screen.flip()
screen.waitVblankStart(5)
	grading_screen_layer:caption(112,62, perfect_count,white,2)
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen:blit(0,0,grading_screen_layer)
	screen.flip()
screen.waitVblankStart(5)
	grading_screen_layer:caption(112,87, great_count,white,2)
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen:blit(0,0,grading_screen_layer)
	screen.flip()
screen.waitVblankStart(5)
	grading_screen_layer:caption(112,112, boo_count,white,2)
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen:blit(0,0,grading_screen_layer)
	screen.flip()
screen.waitVblankStart(5)
	grading_screen_layer:caption(112,137, miss_count,white,2)
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen:blit(0,0,grading_screen_layer)
	screen.flip()
screen.waitVblankStart(5)
	grading_screen_layer:caption(191,214, score,white,4)
	screen:clear()
	screen:blit(0,0,grading_screen)
	screen:blit(0,0,grading_screen_layer)
	screen.flip()

		while not Controls.read():start() do
			screen:clear()
			screen:blit(0,0,grading_screen)
			screen:blit(0,0,grading_screen_layer)
			screen.flip()
			end
quitgame = true
end
---------------------------------------------------------------------------
rotateCube = function()
	cubeAxisRotations.y = cubeAxisRotations.y + userY*difficulty
	cubeAxisRotations.x = cubeAxisRotations.x + userX*difficulty
	local screenPoints = Transform3DPointsTo2DPoints(pointsArray, cubeAxisRotations)
	screen:drawLine(screenPoints[1].x, screenPoints[1].y, screenPoints[2].x, screenPoints[2].y, color.green)
	screen:drawLine(screenPoints[2].x, screenPoints[2].y, screenPoints[3].x, screenPoints[3].y, color.green)
	screen:drawLine(screenPoints[3].x, screenPoints[3].y, screenPoints[4].x, screenPoints[4].y, color.green)
	screen:drawLine(screenPoints[4].x, screenPoints[4].y, screenPoints[1].x, screenPoints[1].y, color.green)
	screen:drawLine(screenPoints[5].x, screenPoints[5].y, screenPoints[6].x, screenPoints[6].y, color.red)
	screen:drawLine(screenPoints[6].x, screenPoints[6].y, screenPoints[7].x, screenPoints[7].y, color.red)
	screen:drawLine(screenPoints[7].x, screenPoints[7].y, screenPoints[8].x, screenPoints[8].y, color.red)
	screen:drawLine(screenPoints[8].x, screenPoints[8].y, screenPoints[5].x, screenPoints[5].y, color.red)
	screen:drawLine(screenPoints[1].x, screenPoints[1].y, screenPoints[5].x, screenPoints[5].y, color.white)
	screen:drawLine(screenPoints[2].x, screenPoints[2].y, screenPoints[6].x, screenPoints[6].y, color.white)
	screen:drawLine(screenPoints[3].x, screenPoints[3].y, screenPoints[7].x, screenPoints[7].y, color.blue)
	screen:drawLine(screenPoints[4].x, screenPoints[4].y, screenPoints[8].x, screenPoints[8].y, color.blue)
end
---------------------------------------------------------------------------
function setup_cube()
focalLength = 300 
make3DPoint = function(x,y,z)
	local point = {}
	point.x = x
	point.y = y
	point.z = z
	return point
	end
make2DPoint = function(x, y)
	local point = {}
	point.x = x+240
	point.y = y+131
	return point
	end
Transform3DPointsTo2DPoints = function(points, axisRotations)
	local TransformedPointsArray = {}
	local sx = math.sin(axisRotations.x)
	local cx = math.cos(axisRotations.x)
	local sy = math.sin(axisRotations.y)
	local cy = math.cos(axisRotations.y)
	local sz = math.sin(axisRotations.z)
	local cz = math.cos(axisRotations.z)
	local x,y,z, xy,xz, yx,yz, zx,zy, scaleRatio
	local i = table.getn(points)

	while (i >0) do
		x = points[i].x
		y = points[i].y
		z = points[i].z
		xy = cx*y - sx*z
		xz = sx*y + cx*z
		yz = cy*xz - sy*x
		yx = sy*xz + cy*x
		-- rotation around z
		zx = cz*yx - sz*xy
		zy = sz*yx + cz*xy
		scaleRatio = focalLength/(focalLength + yz)
		x = zx*scaleRatio
		y = zy*scaleRatio
		TransformedPointsArray[i] = make2DPoint(x, y)
	i = i -1
	end
	return TransformedPointsArray
end

pointsArray = {
make3DPoint(-50,-50,-50),
make3DPoint(50,-50,-50),
make3DPoint(50,-50,50),
make3DPoint(-50,-50,50),
make3DPoint(-50,50,-50),
make3DPoint(50,50,-50),
make3DPoint(50,50,50),
make3DPoint(-50,50,50),
}
cubeAxisRotations = make3DPoint(0,0,0)
userX = - 0.01
userY =  0.01
color = { 
	red = Color.new(255,0,0);
	green = Color.new(0, 255, 0);
	blue = Color.new(0,0,255);
	black = Color.new(0,0,0);
	white = Color.new(255,0,255);
}
end
------------------------------------------------------------------
function drawstarfield()
	screen:clear()
	for i = 1, 50 do
		starfield[i].z = starfield[i].z - 0.1
		if starfield[i].z < 0.1 then createStar(i) end
		starfield_x = 480 / 2 + starfield[i].x / starfield[i].z
		starfield_y = 272 / 2 + starfield[i].y / starfield[i].z
		if starfield_x < 0 or starfield_y < 0 or starfield_x >= 480 or starfield_y >= 272 then
			createStar(i)
		else
			screen:pixel(starfield_x, starfield_y, white)
		end
	end
end
----------------------------------------------------------------
function createStar(i)
	starfield[i] = {}
	starfield[i].x = math.random(2*480) - 480
	starfield[i].y = math.random(2*272) - 272
	starfield[i].z = 5
end
----------------------------------------------------------------
function areyousure()
sure_option = 1
input2 = input
	while true do
		screen.flip()
		screen:blit(165,74,menu)
		screen:print(190,150,"ARE YOU SURE?",red)
		screen:print(230,104,"NO",red)
		screen:print(231,104,"NO",red)
		screen:print(227,121,"YES",red)
		screen:print(228,121,"YES",red)

		if sure_option == 1 then
		screen:print(230,104,"NO",Color.new(0,255,255))
		screen:print(231,104,"NO",Color.new(0,255,255))
		elseif sure_option == 2 then
		screen:print(227,121,"YES",Color.new(0,255,255))
		screen:print(228,121,"YES",Color.new(0,255,255))
		end
		screen.flip()
		input = Controls.read()
		if input ~= input2 then
		input2 = Controls.read()
			if input:up() and sure_option == 2 then
				sure_option = 1
			elseif input:down() and sure_option == 1 then
				sure_option = 2
			end
		if input:cross() then
			if sure_option == 1 then
				areyousureyouwanttoendyourwindowssession = false
				break
			elseif sure_option == 2 then
				areyousureyouwanttoendyourwindowssession = true
				break
			end
		end
		end
	end
end
----------------------------------------------------------------
function ingamemenu()
--createrandom: true or unl
red = Color.new(255,0,0)
menuoption = 1
input2 = input
if bg_animation == "Stars" then

screen:clear(black)
if score/3 <= 256 then
screen:blit(119,0,score_color,0,0,score/3,28)
else
screen:fillRect(119,0,256,28,white)
end
screen:blit(107,0,score_template)
screen:print(226,25,score,color_)

elseif bg_animation == "3D Cube" then
screen:clear(white)
if score/3 <= 256 then
screen:blit(119,0,score_color,0,0,score/3,28)
else
screen:fillRect(119,0,256,28,white)
end
screen:blit(107,0,score_template)
screen:print(226,25,score,color_)

end
	while true do
		--screen:clear()
		screen.flip()
		screen:blit(165,74,menu)
		screen:print(207,104,"CONTINUE",red)
		screen:print(208,104,"CONTINUE",red)
		screen:print(179,121,"END CURRENT GAME",red)
		screen:print(180,121,"END CURRENT GAME",red)
		screen:print(223,138,"QUIT",red)
		screen:print(224,138,"QUIT",red)
			if menuoption == 1 then
				screen:print(207,104,"CONTINUE",Color.new(0,255,255))
				screen:print(208,104,"CONTINUE",Color.new(0,255,255))
			elseif menuoption == 2 then
				screen:print(179,121,"END CURRENT GAME",Color.new(0,255,255))
				screen:print(180,121,"END CURRENT GAME",Color.new(0,255,255))
			elseif menuoption == 3 then
				screen:print(223,138,"QUIT",Color.new(0,255,255))
				screen:print(224,138,"QUIT",Color.new(0,255,255))
			end
		screen.flip()
		input = Controls.read()
			if input ~= input2 then
			input2 = Controls.read()
			if input:up() and menuoption ~= 1 then
				menuoption = menuoption - 1
			elseif input:down() and menuoption ~= 3 then
				menuoption = menuoption + 1
			end
			if input:cross() then
				if menuoption == 1 then
					Music.resume()
					break
				elseif menuoption == 2 then
					areyousure()
						if areyousureyouwanttoendyourwindowssession == true then
						Music.resume()
						quitgame = true
						gameover()
						return
						end
				elseif menuoption == 3 then
					areyousure()
						if areyousureyouwanttoendyourwindowssession == true then
						quitgame = true
						return
						end
				end
			end
			end
	end
end
screen:clear(white)
screen:blit(0,0,loading_screen)
screen.flip()
if createrandom == "false" then
	loadKeys()
elseif createrandom == "true" then
	for a=1,randomvalue do
		random_temp = math.random(4)
		if random_temp == 1 then
			key[a] = "X"
		elseif random_temp == 2 then
			key[a] = "O"
		elseif random_temp == 3 then
			key[a] = "["
		elseif random_temp == 4 then
			key[a] = "^"
		end
	end
end
perfect_count = 0
great_count = 0
boo_count = 0
miss_count = 0
exit = false
quitgame = false
current_y = 300
score = 100
startkeys = 1
show_status = 0
status = ""
startup()
setup_cube()
Music.volume(128)
Music.playFile(bgmusic,true)
collectgarbage()
while true do
	screen:clear(white)
	current_y = current_y - difficulty

	input = Controls.read()
		if input:start() then
			if quitgame then
			else
			Music.pause()
			ingamemenu()
			Music.resume()
			end
		end
	if quitgame then break end 
	if current_y < 30 then
		status = "Miss"
		score = score - 10
		show_status = 25
		miss_count = miss_count + 1
		transferandcreatenew()
	end
	detectinput()
	draw()
	if startkeys-1 == table.getn(key) or score <= 0 then
		gameover()
	end
	screen.flip()
end
Music.stop()
if quitgame then dofile("script.lua") end